# coding: utf-8

"""
    VRt.Studio [ST]

    Veeroute Studio API.  # Description  Server part of the studio.  ## Entity relationship diagram  ![erd](../uml/studio.svg)  # noqa: E501

    The version of the OpenAPI document: 5.12.1831
    Contact: servicedesk@veeroute.com
    Generated by: https://openapi-generator.tech
"""

from datetime import date, datetime  # noqa: F401
import decimal  # noqa: F401
import functools  # noqa: F401
import io  # noqa: F401
import re  # noqa: F401
import typing  # noqa: F401
import typing_extensions  # noqa: F401
import uuid  # noqa: F401

import frozendict  # noqa: F401

from vrt_lss_studio import schemas  # noqa: F401


class Location(
    schemas.DictSchema
):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.

    Location - unique geographical location of the object with accessibility parameters.

    """


    class MetaOapg:
        required = {
            "geopoint",
            "key",
        }
        
        class properties:
            
            
            class key(
                schemas.StrSchema
            ):
            
            
                class MetaOapg:
                    max_length = 1024
                    min_length = 1
        
            @staticmethod
            def geopoint() -> typing.Type['Geopoint']:
                return Geopoint
        
            @staticmethod
            def arrival_duration() -> typing.Type['TimeDuration']:
                return TimeDuration
        
            @staticmethod
            def departure_duration() -> typing.Type['TimeDuration']:
                return TimeDuration
            
            
            class work_windows(
                schemas.ListSchema
            ):
            
            
                class MetaOapg:
                    unique_items = True
                    max_items = 100
                    min_items = 0
                    
                    @staticmethod
                    def items() -> typing.Type['TimeWindow']:
                        return TimeWindow
            
                def __new__(
                    cls,
                    arg: typing.Union[typing.Tuple['TimeWindow'], typing.List['TimeWindow']],
                    _configuration: typing.Optional[schemas.Configuration] = None,
                ) -> 'work_windows':
                    return super().__new__(
                        cls,
                        arg,
                        _configuration=_configuration,
                    )
            
                def __getitem__(self, i: int) -> 'TimeWindow':
                    return super().__getitem__(i)
        
            @staticmethod
            def compatibilities() -> typing.Type['LocationCompatibilities']:
                return LocationCompatibilities
        
            @staticmethod
            def attributes() -> typing.Type['Attributes']:
                return Attributes
            __annotations__ = {
                "key": key,
                "geopoint": geopoint,
                "arrival_duration": arrival_duration,
                "departure_duration": departure_duration,
                "work_windows": work_windows,
                "compatibilities": compatibilities,
                "attributes": attributes,
            }
        additional_properties = schemas.NotAnyTypeSchema
    
    geopoint: 'Geopoint'
    key: MetaOapg.properties.key
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["geopoint"]) -> 'Geopoint': ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["key"]) -> MetaOapg.properties.key: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["arrival_duration"]) -> 'TimeDuration': ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["departure_duration"]) -> 'TimeDuration': ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["work_windows"]) -> MetaOapg.properties.work_windows: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["compatibilities"]) -> 'LocationCompatibilities': ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["attributes"]) -> 'Attributes': ...
    
    def __getitem__(self, name: typing.Union[typing_extensions.Literal["geopoint"], typing_extensions.Literal["key"], typing_extensions.Literal["arrival_duration"], typing_extensions.Literal["departure_duration"], typing_extensions.Literal["work_windows"], typing_extensions.Literal["compatibilities"], typing_extensions.Literal["attributes"], ]):
        # dict_instance[name] accessor
        return super().__getitem__(name)
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["geopoint"]) -> 'Geopoint': ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["key"]) -> MetaOapg.properties.key: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["arrival_duration"]) -> typing.Union['TimeDuration', schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["departure_duration"]) -> typing.Union['TimeDuration', schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["work_windows"]) -> typing.Union[MetaOapg.properties.work_windows, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["compatibilities"]) -> typing.Union['LocationCompatibilities', schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["attributes"]) -> typing.Union['Attributes', schemas.Unset]: ...
    
    def get_item_oapg(self, name: typing.Union[typing_extensions.Literal["geopoint"], typing_extensions.Literal["key"], typing_extensions.Literal["arrival_duration"], typing_extensions.Literal["departure_duration"], typing_extensions.Literal["work_windows"], typing_extensions.Literal["compatibilities"], typing_extensions.Literal["attributes"], ]):
        return super().get_item_oapg(name)

    def __new__(
        cls,
        *args: typing.Union[dict, frozendict.frozendict, ],
        geopoint: 'Geopoint',
        key: typing.Union[MetaOapg.properties.key, str, ],
        arrival_duration: typing.Union['TimeDuration', schemas.Unset] = schemas.unset,
        departure_duration: typing.Union['TimeDuration', schemas.Unset] = schemas.unset,
        work_windows: typing.Union[MetaOapg.properties.work_windows, list, tuple, schemas.Unset] = schemas.unset,
        compatibilities: typing.Union['LocationCompatibilities', schemas.Unset] = schemas.unset,
        attributes: typing.Union['Attributes', schemas.Unset] = schemas.unset,
        _configuration: typing.Optional[schemas.Configuration] = None,
    ) -> 'Location':
        return super().__new__(
            cls,
            *args,
            geopoint=geopoint,
            key=key,
            arrival_duration=arrival_duration,
            departure_duration=departure_duration,
            work_windows=work_windows,
            compatibilities=compatibilities,
            attributes=attributes,
            _configuration=_configuration,
        )

from vrt_lss_studio.model.attributes import Attributes
from vrt_lss_studio.model.geopoint import Geopoint
from vrt_lss_studio.model.location_compatibilities import LocationCompatibilities
from vrt_lss_studio.model.time_duration import TimeDuration
from vrt_lss_studio.model.time_window import TimeWindow
