# do not import all endpoints into this module because that uses a lot of memory and stack frames
# if you need the ability to import all endpoints from this module, import them with
# from vrt_lss_studio.apis.path_to_api import path_to_api

import enum


class PathValues(str, enum.Enum):
    STUDIO_EXPLORER = "/studio/explorer"
    STUDIO_EXPLORER_FOLDER_KEY = "/studio/explorer/{folder_key}"
    STUDIO_EXPLORER_FOLDER_KEY_DUPLICATION = "/studio/explorer/{folder_key}/duplication"
    STUDIO_EXPERIMENTS = "/studio/experiments"
    STUDIO_EXPERIMENTS_EXPERIMENT_KEY = "/studio/experiments/{experiment_key}"
    STUDIO_EXPERIMENTS_EXPERIMENT_KEY_DUPLICATION = "/studio/experiments/{experiment_key}/duplication"
    STUDIO_EXPERIMENTS_EXPERIMENT_KEY_SETTINGS = "/studio/experiments/{experiment_key}/settings"
    STUDIO_EXPERIMENTS_EXPERIMENT_KEY_INDICATORS = "/studio/experiments/{experiment_key}/indicators"
    STUDIO_EXPERIMENTS_EXPERIMENT_KEY_CALCULATION_PROCESS_NAME = "/studio/experiments/{experiment_key}/calculation/{process_name}"
    STUDIO_EXPERIMENTS_EXPERIMENT_KEY_CALCULATION = "/studio/experiments/{experiment_key}/calculation"
    STUDIO_EXPERIMENTS_EXPERIMENT_KEY_VALIDATION_PROCESS_NAME = "/studio/experiments/{experiment_key}/validation/{process_name}"
    STUDIO_EXPERIMENTS_EXPERIMENT_KEY_SHARE = "/studio/experiments/{experiment_key}/share"
    STUDIO_EXPERIMENTS_EXPERIMENT_KEY_IMPORT_XLSX = "/studio/experiments/{experiment_key}/import/xlsx"
    STUDIO_EXPERIMENTS_EXPERIMENT_KEY_IMPORT_JSON = "/studio/experiments/{experiment_key}/import/json"
    STUDIO_EXPERIMENTS_EXPERIMENT_KEY_IMPORT_JSON_URL = "/studio/experiments/{experiment_key}/import/json_url"
    STUDIO_EXPERIMENTS_EXPERIMENT_KEY_EXPORT_XLSX = "/studio/experiments/{experiment_key}/export/xlsx"
    STUDIO_EXPERIMENTS_EXPERIMENT_KEY_EXPORT_JSON = "/studio/experiments/{experiment_key}/export/json"
    STUDIO_EXPERIMENTS_EXPERIMENT_KEY_LOCATIONS_LIST = "/studio/experiments/{experiment_key}/locations/list"
    STUDIO_EXPERIMENTS_EXPERIMENT_KEY_LOCATIONS = "/studio/experiments/{experiment_key}/locations"
    STUDIO_EXPERIMENTS_EXPERIMENT_KEY_LOCATIONS_ESSENCE_KEY = "/studio/experiments/{experiment_key}/locations/{essence_key}"
    STUDIO_EXPERIMENTS_EXPERIMENT_KEY_LOCATIONS_GEOPOINTS = "/studio/experiments/{experiment_key}/locations/geopoints"
    STUDIO_EXPERIMENTS_EXPERIMENT_KEY_PERFORMERS_LIST = "/studio/experiments/{experiment_key}/performers/list"
    STUDIO_EXPERIMENTS_EXPERIMENT_KEY_PERFORMERS = "/studio/experiments/{experiment_key}/performers"
    STUDIO_EXPERIMENTS_EXPERIMENT_KEY_PERFORMERS_ESSENCE_KEY = "/studio/experiments/{experiment_key}/performers/{essence_key}"
    STUDIO_EXPERIMENTS_EXPERIMENT_KEY_PERFORMERS_GEOPOINTS = "/studio/experiments/{experiment_key}/performers/geopoints"
    STUDIO_EXPERIMENTS_EXPERIMENT_KEY_TRANSPORTS_LIST = "/studio/experiments/{experiment_key}/transports/list"
    STUDIO_EXPERIMENTS_EXPERIMENT_KEY_TRANSPORTS = "/studio/experiments/{experiment_key}/transports"
    STUDIO_EXPERIMENTS_EXPERIMENT_KEY_TRANSPORTS_ESSENCE_KEY = "/studio/experiments/{experiment_key}/transports/{essence_key}"
    STUDIO_EXPERIMENTS_EXPERIMENT_KEY_TRANSPORTS_GEOPOINTS = "/studio/experiments/{experiment_key}/transports/geopoints"
    STUDIO_EXPERIMENTS_EXPERIMENT_KEY_ORDERS_LIST = "/studio/experiments/{experiment_key}/orders/list"
    STUDIO_EXPERIMENTS_EXPERIMENT_KEY_ORDERS = "/studio/experiments/{experiment_key}/orders"
    STUDIO_EXPERIMENTS_EXPERIMENT_KEY_ORDERS_ESSENCE_KEY = "/studio/experiments/{experiment_key}/orders/{essence_key}"
    STUDIO_EXPERIMENTS_EXPERIMENT_KEY_ORDERS_GEOPOINTS = "/studio/experiments/{experiment_key}/orders/geopoints"
    STUDIO_EXPERIMENTS_EXPERIMENT_KEY_HARDLINKS_LIST = "/studio/experiments/{experiment_key}/hardlinks/list"
    STUDIO_EXPERIMENTS_EXPERIMENT_KEY_HARDLINKS = "/studio/experiments/{experiment_key}/hardlinks"
    STUDIO_EXPERIMENTS_EXPERIMENT_KEY_HARDLINKS_ESSENCE_KEY = "/studio/experiments/{experiment_key}/hardlinks/{essence_key}"
    STUDIO_EXPERIMENTS_EXPERIMENT_KEY_TRIPS_LIST = "/studio/experiments/{experiment_key}/trips/list"
    STUDIO_EXPERIMENTS_EXPERIMENT_KEY_TRIPS = "/studio/experiments/{experiment_key}/trips"
    STUDIO_EXPERIMENTS_EXPERIMENT_KEY_TRIPS_ESSENCE_KEY = "/studio/experiments/{experiment_key}/trips/{essence_key}"
    STUDIO_EXPERIMENTS_EXPERIMENT_KEY_TRIPS_TRACKS = "/studio/experiments/{experiment_key}/trips/tracks"
    STUDIO_SYSTEM_CHECK = "/studio/system/check"
    STUDIO_SYSTEM_VERSION = "/studio/system/version"
    STUDIO_FILE_FILENAME = "/studio/file/{filename}"
